SystemOrganization addCategory: #BichOS!
SystemOrganization addCategory: 'BichOS-Tests'!

TestCase subclass: #TestsAlimentos
	instanceVariableNames: 'roberta lugares1 inicio punto1 punto2 punto3 punto4 galletita pan alfajor zapatilla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:23'!
setUp
	roberta := Hormiga new.
	
	lugares1 := Set new.
	
	roberta lugaresDondeEstuvo: lugares1.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	punto4 := Ubicacion new.
	punto4 unidadesX: 2.
	punto4 unidadesY: 3.
	
	galletita := Comida new.
	pan := Comida new.
	alfajor := Alfajor crearConEstosChips: 8.
	zapatilla := Comida new.
	
	galletita cantidadDeAlimento: 10000.
	pan cantidadDeAlimento: 2000.
	zapatilla cantidadDeAlimento: 0.
	
	roberta ubicacion: inicio.	
	galletita ubicacion: punto1.
	pan ubicacion: punto2.
	alfajor ubicacion: punto3.
	zapatilla ubicacion: punto4.
	! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:36'!
testExtraerAlimentoDeAlfajor
	roberta extraerAlimentoDe: alfajor.
	self assert:((alfajor cantidadDeAlimento)=159989).! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:37'!
testExtraerAlimentoDeGalletitaOreo
	roberta extraerAlimentoDe: galletita.
	self assert:((galletita cantidadDeAlimento)=9989).! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:37'!
testExtraerAlimentoDeMigaDePan
	roberta extraerAlimentoDe: pan.
	self assert:((pan cantidadDeAlimento)=1989).! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:42'!
testExtraerAlimentoDeZapatilla
	roberta extraerAlimentoDe: zapatilla.
	self assert:((roberta alimentoTransportado)=5).! !

TestCase subclass: #TestsCansancio
	instanceVariableNames: 'roberta juancita petunia hormigas hormiguero origen inicio punto1 punto2 punto3 lugares1 punto4 galletita pan alfajor zapatilla punto5 punto6 puntoAlejado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsCansancio methodsFor: 'as yet unclassified' stamp: 'as 10/19/2015 00:04'!
setUp
	roberta := Hormiga new.
	juancita := Hormiga new.
	petunia := Hormiga new.
	
	hormigas := Set new.
	hormigas addAll: {roberta. juancita. petunia}.
	hormiguero := Hormiguero new.
	hormiguero hormigasQueTiene: hormigas.
	hormiguero deposito:0.
	
	origen := Ubicacion new.
	origen unidadesX: 0.
	origen unidadesY: 0.
	hormiguero ubicacion: origen.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	punto4 := Ubicacion new.
	punto4 unidadesX: 2.
	punto4 unidadesY: 3.
	
	punto5 := Ubicacion new.
	punto5 unidadesX: 1.
	punto5 unidadesY: 0.
	
	punto6 := Ubicacion new.
	punto6 unidadesX: 0.
	punto6 unidadesY: 2.
	
	puntoAlejado := Ubicacion new.
	puntoAlejado unidadesX: 12.
	puntoAlejado unidadesY: 1.
	
	galletita := Comida new.
	pan := Comida new.
	alfajor := Alfajor crearConEstosChips: 8.
	zapatilla := Comida new.
	
	galletita cantidadDeAlimento: 10000.
	pan cantidadDeAlimento: 2000.
	zapatilla cantidadDeAlimento: 0.
	
	roberta ubicacion: inicio.	
	juancita ubicacion: punto5.
	petunia ubicacion: punto6.
	galletita ubicacion: punto1.
	pan ubicacion: punto2.
	alfajor ubicacion: punto3.
	zapatilla ubicacion: punto4.
	! !

!TestsCansancio methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 19:07'!
testCuandoHormigaCansadaDescansaYRecolectaAlimento
roberta cansate.
roberta descansar.
roberta extraerAlimentoDe: alfajor.
self assert: ((roberta alimentoTransportado)= 10).! !

!TestsCansancio methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 19:11'!
testCuandoHormigaExaltadaPasaALaNormalidadYRecolectaAlimento
roberta descansar.
roberta moveteA: punto1.
roberta extraerAlimentoDe: alfajor.
self assert: ((roberta alimentoTransportado)= 10).! !

!TestsCansancio methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 19:08'!
testCuandoHormigaNormalDescansaYRecolectaAlimento
roberta descansar.
roberta extraerAlimentoDe: alfajor.
self assert: ((roberta alimentoTransportado)= 20).! !

!TestsCansancio methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 19:05'!
testCuandoHormigaRecorreMasDe10mtsYSeLeOrdenaRecolectar
roberta moveteA: puntoAlejado.
roberta extraerAlimentoDe: alfajor.
self assert:((roberta alimentoTransportado)=0).! !

!TestsCansancio methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 19:03'!
testCuandoHormigaSeCansaYSeLeOrdenaMoverse
roberta moveteA: puntoAlejado.
roberta moveteA: inicio.
self assert: ((roberta ubicacion)= puntoAlejado).! !

TestCase subclass: #TestsDeRecorridos
	instanceVariableNames: 'roberta punto1 punto2 punto3 inicio lugaresDondeEstuvo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:03'!
setUp
	roberta := Hormiga new.
	lugaresDondeEstuvo := Set new.
	roberta lugaresDondeEstuvo: lugaresDondeEstuvo.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	roberta ubicacion: inicio.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	
	! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:02'!
testDistaciaCuandoVaDeinicioAPunto1yDespuesAPunto2
	roberta moveteA: punto1.
	roberta moveteA: punto2.
	self assert:((roberta distanciaRecorrida) = 4.23606797749979).! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:04'!
testDistanciaCuandoVaDeInicioAPunto1
	roberta moveteA: punto1.
	self assert: ((roberta distanciaRecorrida) = 2).
	! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:10'!
testDistanciaPromedioCuandoVaAPunto1yDespuesAPunto3
	roberta moveteA: punto1.
	roberta moveteA: punto3.
	self assert: ((roberta distanciaPromedioRecorrida)=3).! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 21:57'!
testLugaresDondeEstuvoCuandoVaDeInicioAPunto1yDespuesAPunto2
	roberta moveteA: punto1.
	roberta moveteA: punto2.
	self assertCollection: (roberta lugaresDondeEstuvo) equals: ({inicio. punto1.} as: (roberta lugaresDondeEstuvo) class)! !

TestCase subclass: #TestsHormiguero
	instanceVariableNames: 'roberta juancita petunia hormigas hormiguero origen lugares1 lugares2 lugares3 inicio punto1 punto2 punto3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:02'!
setUp
	roberta := Hormiga new.
	juancita := Hormiga new.
	petunia := Hormiga new.
	
	hormigas := Set new.
	hormigas addAll: {roberta. juancita. petunia}.
	hormiguero := Hormiguero new.
	hormiguero hormigasQueTiene: hormigas.
	hormiguero deposito:0.
	
	origen := Ubicacion new.
	origen unidadesX: 0.
	origen unidadesY: 0.
	hormiguero ubicacion: origen.
	
	lugares1 := Set new.
	lugares2 := Set new.
	lugares3 := Set new.
	
	roberta lugaresDondeEstuvo: lugares1.
	juancita lugaresDondeEstuvo: lugares2.
	petunia lugaresDondeEstuvo: lugares3.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	roberta ubicacion: inicio.	
	petunia ubicacion: punto1.
	juancita ubicacion: punto2.! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:42'!
testCantidadDeAlimentoEnDeposito
	roberta alimentoTransportado: 5.
	juancita alimentoTransportado: 8.
	petunia alimentoTransportado: 2.
	hormiguero recaudarAlimento.
	self assert:((hormiguero deposito)=15).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:43'!
testCantidadDeAlimentoQueLlevan3Hormigas
	roberta alimentoTransportado: 3.
	self assert:((hormiguero cantidadDeAlimentoQueLlevan)=3).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:43'!
testCantidadDeAlimentoTotalDepositoEn15y3Hormigas
	roberta alimentoTransportado: 5.
	juancita alimentoTransportado: 8.
	petunia alimentoTransportado: 2.
	hormiguero deposito:15.
	self assert:((hormiguero cantidadDeAlimentoTotal)=30).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:00'!
testCuantasHormigasTieneConAlgunasHormigas
	self assert:((hormiguero cantidadDeHormigas)=3).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:59'!
testCuantasHormigasTieneUnHormigueroVacio
	hormiguero hormigasQueTiene: {  }.
	self assert:((hormiguero cantidadDeHormigas)=0).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:21'!
testDistanciaRecorridaPor3Hormigas
	roberta moveteA: punto1.
	juancita moveteA: inicio.
	petunia moveteA: punto3.
	roberta moveteA: punto3.
	
	self assert: ((hormiguero distanciaRecorridaPorSusHormigas)=11).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:12'!
testRecaudarAlimentoPara3Hormigas
	hormiguero recaudarAlimento.
	self assert:((roberta alimentoTransportado)=0).! !

TestCase subclass: #testsAlimentoTransportado
	instanceVariableNames: 'roberta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:47'!
setUp
	roberta := Hormiga new.! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 10/19/2015 00:20'!
testCuandoAlimentoTransportadoEs0
	self assert: (roberta alimentoTransportado = 0).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 10/19/2015 00:21'!
testCuandoAlimentoTransportadoEs5
	roberta alimentoTransportado: 5.
	self assert: (roberta alimentoTransportado = 5).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:59'!
testEstaAlLimiteSiLleva9mg
	roberta alimentoTransportado: 9.
	self assert: (roberta estaAlLimite).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:58'!
testNoEstaAlLimiteSiLleva5mg
	self assert:( roberta estaAlLimite not).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:57'!
testNoEstaAlLimiteSiNoLlevaNada
	roberta alimentoTransportado: 0.
	self assert: (roberta estaAlLimite not).! !

Object subclass: #Colonia
	instanceVariableNames: 'hormigueros'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Colonia methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:28'!
agregarHormiguero: unHormiguero
self hormigueros add: unHormiguero.! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:55'!
atacarEnemigo:unInsecto

[self perteneceA: unInsecto] ifFalse:[
self hormigueros do:[:hormiguero|hormiguero atacarEnemigo: unInsecto]
].! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:44'!
cantidadDeHormigas

self hormiguero sum:[:unHormiguero| unHormiguero cantidadDeHormigas ]! !

!Colonia methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 11:28'!
hormigueros
	^ hormigueros! !

!Colonia methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 11:28'!
hormigueros: anObject
	hormigueros := anObject! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:55'!
perteneceA:unInsecto
^(self hormigueros anySatisfy: [ :hormiguero|hormiguero perteneceA: unInsecto])! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:44'!
recaudarAlimento
self hormigueros do:[:unHormiguero| unHormiguero recaudarAlimento]! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:45'!
recaudarAlimentoAlLimite
self hormigueros do:[:unHormiguero| unHormiguero recaudarAlimentoAlLimite]! !

Object subclass: #ColoniadeColonias
	instanceVariableNames: 'cosasDeLaColonia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!ColoniadeColonias methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:50'!
agregar: algo
self cosasDeLaColonia add: algo.! !

!ColoniadeColonias methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:53'!
atacarEnemigo:unInsecto

[self perteneceA: unInsecto] ifFalse:[
self cosasDeLaColonia do:[:hormiguero|hormiguero atacarEnemigo: unInsecto]
].! !

!ColoniadeColonias methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:51'!
cantidadDeHormigas

self cosasDeLaColonia sum:[:unHormiguero| unHormiguero cantidadDeHormigas ]! !

!ColoniadeColonias methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:53'!
perteneceA:unInsecto
^(self cosasDeLaColonia anySatisfy: [ :hormiguero|hormiguero perteneceA: unInsecto])! !

!ColoniadeColonias methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:48'!
recaudarAlimento
self hormigueros do:[:unHormiguero| unHormiguero recaudarAlimento]! !

!ColoniadeColonias methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:48'!
recaudarAlimentoAlLimite
self hormigueros do:[:unHormiguero| unHormiguero recaudarAlimentoAlLimite]! !

Object subclass: #Comida
	instanceVariableNames: 'cantidadDeAlimento ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Comida commentStamp: '<historical>' prior: 0!
A Comida is xxxxxxxxx.

Instance Variables
	cantidadDeAlimento:		<Object>
	ubicacion:		<Object>

cantidadDeAlimento
	- xxxxx

ubicacion
	- xxxxx
!

Comida subclass: #Alfajor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Alfajor commentStamp: '<historical>' prior: 0!
An Alfajor is xxxxxxxxx.

Instance Variables
	chipsDeChocolate:		<Object>

chipsDeChocolate
	- xxxxx
!

!Alfajor class methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:33'!
crearConEstosChips: unosChips
	|alfajor|
	alfajor := Alfajor new.
	alfajor cantidadDeAlimento: (20000 * unosChips).
	^alfajor.! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
cantidadDeAlimento
	^ cantidadDeAlimento! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
cantidadDeAlimento: anObject
	cantidadDeAlimento := anObject! !

!Comida methodsFor: 'yerbamala' stamp: 'as 9/21/2015 16:05'!
perdeMasa: unaCantidad
	self cantidadDeAlimento: self cantidadDeAlimento - unaCantidad - 1.! !

!Comida methodsFor: 'yerbamala' stamp: 'as 10/12/2015 23:32'!
sePuedeExtraerAlimento
 	(self cantidadDeAlimento = 0) 
		ifTrue: [self error: 'No quedan restos en este alimento']
		ifFalse: [ ^true ]! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
ubicacion
	^ ubicacion! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
ubicacion: anObject
	ubicacion := anObject! !

Object subclass: #EstadoCansada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!EstadoCansada commentStamp: '<historical>' prior: 0!
An EstadoCansada is xxxxxxxxx.
!

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:51'!
entregarAlimentoA: unHormiguero con: unaHormiga! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:52'!
extraerDe: unaComida con: unaHormiga! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:52'!
moveA: unaHormiga hasta: nuevaUbicacion! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:53'!
recomponerA: unaHormiga
	unaHormiga estado: EstadoNormal new.! !

Object subclass: #EstadoEstaticaViva
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!EstadoEstaticaViva methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:03'!
capacidadMaximaSegunEstado
	^1
	! !

!EstadoEstaticaViva methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:07'!
entregarAlimentoA: unHormiguero con: unaHormiga
	unaHormiga depositaAlimentoEn: unHormiguero.! !

!EstadoEstaticaViva methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:02'!
extraerDe: unaComida con: unaHormiga
! !

!EstadoEstaticaViva methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:02'!
moveA: unaHormiga hasta: nuevaUbicacion
! !

!EstadoEstaticaViva methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:02'!
recomponerA: unaHormiga
! !

!EstadoEstaticaViva methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:03'!
tieneLugar: unaHormiga
	^false.! !

Object subclass: #EstadoMuerta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 19:56'!
capacidadMaximaSegunEstado
	^0
	! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:00'!
entregarAlimentoA: unHormiguero con: unaHormiga
	self error:'Estoy morida, no puedo hacer nada wachen'.! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:00'!
extraerDe: unaComida con: unaHormiga
	
	self error:'Estoy morida, no puedo hacer nada wachen'.! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:00'!
moveA: unaHormiga hasta: nuevaUbicacion
		self error:'Estoy morida, no puedo hacer nada wachen'.! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:00'!
recomponerA: unaHormiga
	self error:'Estoy morida, no puedo hacer nada wachen'.! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:00'!
tieneLugar: unaHormiga
	self error:'Estoy morida, no puedo hacer nada wachen'.! !

Object subclass: #EstadoNormal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!EstadoNormal commentStamp: '<historical>' prior: 0!
An EstadoNormal is xxxxxxxxx.
!

EstadoNormal subclass: #EstadoExaltada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!EstadoExaltada commentStamp: '<historical>' prior: 0!
An EstadoExaltada is xxxxxxxxx.
!

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:00'!
capacidadMaximaSegunEstado
	^20.! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 17:24'!
extraerDe: unaComida con: unaHormiga
	super extraerDe: unaComida con: unaHormiga.
	unaHormiga alimentoTransportado:20.! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'as 10/19/2015 00:24'!
moveA: unaHormiga hasta: nuevaUbicacion
	|ubicacionAnterior|
	ubicacionAnterior := unaHormiga ubicacion.
	super moveA: unaHormiga hasta: nuevaUbicacion.
	unaHormiga sumaDistanciaAcumuladaDesde: ubicacionAnterior.
	unaHormiga evaluaSiPasasALaNormalidad.
	! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:55'!
recomponerA: unaHormiga! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 17:23'!
tieneLugar: unaHormiga
	^(unaHormiga alimentoTransportado <= 20).! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 18:00'!
capacidadMaximaSegunEstado
	^10
	! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:45'!
entregarAlimentoA: unHormiguero con: unaHormiga
	unaHormiga moveteA: (unHormiguero ubicacion).
	unaHormiga depositaAlimentoEn: unHormiguero.! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 19:23'!
extraerDe: unaComida con: unaHormiga
	
	((unaComida sePuedeExtraerAlimento) and: (unaHormiga tengoLugar)) 
	
	ifTrue:[	
			unaComida perdeMasa: (unaHormiga capacidadDisponible). 
			unaHormiga alimentoTransportado: 10.
			]. ! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'as 10/19/2015 00:19'!
moveA: unaHormiga hasta: nuevaUbicacion
	|ubicacionAnterior|
	ubicacionAnterior := unaHormiga ubicacion.
	unaHormiga ubicacion: nuevaUbicacion.
	unaHormiga agregarALugarDondeEstuvo: ubicacionAnterior.
	unaHormiga sumarDistanciaRecorridaDesde: ubicacionAnterior.
	unaHormiga incrementarCantidadDeViajes.
	
	((ubicacionAnterior distanciaA: nuevaUbicacion) > 10) ifTrue: [ unaHormiga cansate].! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 17:48'!
recomponerA: unaHormiga
	unaHormiga estado: EstadoExaltada new.
	unaHormiga distanciaAcumulada: 0.! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 17:21'!
tieneLugar: unaHormiga
	^(unaHormiga alimentoTransportado <= 10).! !

Object subclass: #Expedicion
	instanceVariableNames: 'hormigas hormiguero objetivo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Expedicion class methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:48'!
crearCon: unHormiguero objetivo: unaComida
	|unaExpedicion hormigas|
	self validarCantidadDeHormigas: (unHormiguero hormigasObreras)  con: unaComida.
	unaExpedicion := Expedicion new.
	unaExpedicion hormiguero: unHormiguero.
	unaExpedicion agregarHormigasDe: unHormiguero.
	hormigas:= Set new.
	
	unaExpedicion objetivo: unaComida.
	
	(   (( hormigas) length < (self hormigasNecesariaPara: unaComida) whileTrue:[  ( hormigas) add: ( unHormiguero hormigasObreras ) anyOne  ]  ) ).
	(unHormiguero hormigasQueTiene) removeAGroup: hormigas.
	unaExpedicion hormigas: hormigas.
	
	
	
	
^unaExpedicion.! !

!Expedicion class methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:12'!
hormigasNecesariaPara: unaComida
	^(unaComida cantidadDeAlimento / 10)! !

!Expedicion class methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:26'!
validarCantidadDeHormigas:unasHormigas con: unaComida.
	(unasHormigas >= self hormigasNecesariaPara: unaComida) ifFalse:[ self error: 'Te faltan hormigas para crear la expedicion']! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:35'!
agregarHormigasDe: unHormiguero
	self hormigas! !

!Expedicion methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 12:43'!
hormigas
	^ hormigas! !

!Expedicion methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 12:43'!
hormigas: anObject
	hormigas := anObject! !

!Expedicion methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 12:43'!
hormiguero
	^ hormiguero! !

!Expedicion methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 12:43'!
hormiguero: anObject
	hormiguero := anObject! !

!Expedicion methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 12:43'!
objetivo
	^ objetivo! !

!Expedicion methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 12:43'!
objetivo: anObject
	objetivo := anObject! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigasQueTiene deposito ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Hormiguero commentStamp: '<historical>' prior: 0!
A Hormiguero is xxxxxxxxx.

Instance Variables
	deposito:		<Object>
	hormigasQueTiene:		<Object>

deposito
	- xxxxx

hormigasQueTiene
	- xxxxx
!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:53'!
cantidadDeAlimentoQueLlevan
	^( self hormigasQueTiene sum:[: unaHormiga | unaHormiga alimentoTransportado.]).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:53'!
cantidadDeAlimentoTotal
	^(self deposito + self cantidadDeAlimentoQueLlevan).! !

!Hormiguero methodsFor: 'mensajes universales' stamp: 'as 9/9/2015 23:31'!
cantidadDeHormigas
	^( self hormigasQueTiene size).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:01'!
cantidadDeHormigasAlLimite
	^(self hormigasAlLimite) size. ! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:54'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:54'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:17'!
distanciaRecorridaPorSusHormigas
	^self hormigasQueTiene sum:[:unaHormiga | unaHormiga distanciaRecorrida].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 19:04'!
eliminaA: unaHormiga
	self hormigasQueTiene remove: unaHormiga.! !

!Hormiguero methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 11:56'!
esEnemigo: unInsecto
^((self perteneceA: unInsecto)not) & ( self estaAMenosDeDosMetros: unInsecto  )   ! !

!Hormiguero methodsFor: 'accessing' stamp: 'Anonymous 10/29/2015 11:25'!
estaAMenosDeDosMetros:unInsecto
^(  ( (unInsecto ubicacion) distanciaA: self ubicacion )<2  )! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:01'!
hormigasAlLimite
	^(self hormigasQueTiene select:[: unaHormiga | unaHormiga estaAlLimite.])! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:30'!
hormigasObreras
^ (self hormigasQueTiene select:[:unaHormiga|unaHormiga esObrera])! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:30'!
hormigasQueTiene
	^ hormigasQueTiene! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:30'!
hormigasQueTiene: anObject
	hormigasQueTiene := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:56'!
perteneceA: unInsecto
^( (self hormigasQueTiene) includes: unInsecto)! !

!Hormiguero methodsFor: 'mensajes universales' stamp: 'as 10/18/2015 15:49'!
recaudarAlimento
	self hormigasQueTiene do:[: unaHormiga | unaHormiga entregarAlimentoA: self].
	! !

!Hormiguero methodsFor: 'mensajes universales' stamp: 'Anonymous 10/29/2015 11:27'!
recaudarAlimentoAlLimite
	self hormigasAlLimite do:[: unaHormiga | unaHormiga entregarAlimentoA: self].
	! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 10/18/2015 16:33'!
recibirAlimentoDeUnaHormiga: unaCantidad
	self deposito: self deposito + unaCantidad.! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:13'!
ubicacion
	^ ubicacion! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:13'!
ubicacion: anObject
	ubicacion := anObject! !

Hormiguero subclass: #HormigueroCerca
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!HormigueroCerca methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/28/2015 20:45'!
atacarEnemigo: unInsecto
(self hormigasCerca) do: [:hormiga | hormiga atacar: unInsecto]! !

!HormigueroCerca methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 10:36'!
hormigasCerca
^((self hormigasQueTiene) select: [:hormiga | hormiga estaCercaDe: (self ubicacion)])! !

Hormiguero subclass: #HormigueroCualquiera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!HormigueroCualquiera methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 10:52'!
atacarEnemigo: unInsecto

self hormigasRamdon do: [:hormiga | hormiga atacar: unInsecto ]! !

!HormigueroCualquiera methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:05'!
hormigaRamdon
|hormigas|

hormigas:= Set new.

(   (hormigas length <10) whileTrue:[  hormigas add: (self hormigasQueTiene) anyOne  ]  ).

^hormigas.
! !

Hormiguero subclass: #HormigueroViolento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!HormigueroViolento methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:10'!
atacarEnemigo: unInsecto
self hormigasViolentas do:[:hormiga|hormiga atacar: unInsecto]! !

!HormigueroViolento methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:11'!
hormigasViolentas
^(self hormigasQueTiene select:[:hormiga|hormiga esViolenta ])! !

Object subclass: #InsectoBase
	instanceVariableNames: 'ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

InsectoBase subclass: #Hormiga
	instanceVariableNames: 'estado hormiguero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:31'!
esObrera
^false.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 11:08'!
esViolenta
^false.! !

!Hormiga methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/28/2015 19:59'!
morite	
	self estado: EstadoMuerta new.
	(self hormiguero) eliminaA: self.! !

!Hormiga methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/28/2015 20:10'!
moveteA: unaUbicacion
	(self estado) moveA: self hasta: unaUbicacion.! !

Hormiga subclass: #HormigaEstatica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!HormigaEstatica methodsFor: 'metodos cansadores' stamp: 'as 10/26/2015 18:38'!
atacar: unInsecto
! !

!HormigaEstatica methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/26/2015 16:05'!
ataque
^0.! !

!HormigaEstatica methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:24'!
depositaAlimentoEn: unHormiguero
	unHormiguero recibirAlimentoDeUnaHormiga: (self alimentoTransportado).
! !

!HormigaEstatica methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:36'!
distanciaAcumulada
	^ 
	0.! !

!HormigaEstatica methodsFor: 'yerbabrava' stamp: 'Anonymous 10/25/2015 22:36'!
distanciaRecorrida
	^0.! !

!HormigaEstatica methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/28/2015 20:06'!
entregarAlimentoA: unHormiguero
(self estado) entregarAlimentoA: unHormiguero con: self.

	! !

!HormigaEstatica methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/28/2015 19:53'!
extraerAlimentoDe: unaComida
	self moveteA: (unaComida ubicacion).
	(self estado) extraerDe: unaComida con: self.
	
	! !

!HormigaEstatica methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 10:46'!
initialize
	estado := EstadoEstaticaViva  new.
	ubicacion := Ubicacion new.! !

!HormigaEstatica methodsFor: 'metodos cansadores' stamp: 'as 10/26/2015 18:51'!
recibirDaño: unInsecto
	self morite! !

HormigaEstatica subclass: #Reina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Reina methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:37'!
alimentoTransportado
	^ 0.! !

!Reina methodsFor: 'yerbabrava' stamp: 'Anonymous 10/29/2015 10:25'!
estaAlLimite
	^ false.! !

HormigaEstatica subclass: #Zangano
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Zangano methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:36'!
alimentoTransportado
	^ 1.! !

!Zangano methodsFor: 'yerbabrava' stamp: 'Anonymous 10/25/2015 22:37'!
estaAlLimite
	^ True.! !

Hormiga subclass: #HormigaMovil
	instanceVariableNames: 'lugaresDondeEstuvo distanciaRecorrida cantidadDeViajes distanciaAcumulada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:13'!
agregarALugarDondeEstuvo: unaUbicacion
	self lugaresDondeEstuvo add: unaUbicacion.! !

!HormigaMovil methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/26/2015 15:14'!
cansate
	self estado: EstadoCansada new.! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:21'!
cantidadDeViajes
	^ cantidadDeViajes! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:14'!
cantidadDeViajes: anObject
	cantidadDeViajes := anObject! !

!HormigaMovil methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/26/2015 15:15'!
descansar
	(self estado) recomponerA: self.! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:21'!
distanciaAcumulada
	^ 
	distanciaAcumulada! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:15'!
distanciaAcumulada: anObject
	
	distanciaAcumulada := anObject! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/25/2015 22:39'!
distanciaPromedioRecorrida
	^(self distanciaRecorrida / (self cantidadDeViajes)).! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/25/2015 22:23'!
distanciaRecorrida
	^ distanciaRecorrida! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:16'!
distanciaRecorrida: anObject
	distanciaRecorrida := anObject! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/29/2015 10:35'!
estaCercaDe: unaUbicacion
	^ ((self ubicacion )distanciaA: unaUbicacion)<0.5 ! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:17'!
estado
	^ estado! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:17'!
estado: anObject
	estado := anObject! !

!HormigaMovil methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/26/2015 15:17'!
evaluaSiPasasALaNormalidad
	((self distanciaAcumulada) > 5) ifTrue: [ self volveALaNormalidad].! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:19'!
incrementarCantidadDeViajes
	self cantidadDeViajes: self cantidadDeViajes + 1.! !

!HormigaMovil methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/26/2015 15:59'!
initialize
	estado := EstadoNormal new.
	distanciaRecorrida := 0.
	cantidadDeViajes :=0.
	distanciaAcumulada := 0.
	lugaresDondeEstuvo := Set new.
	ubicacion := Ubicacion new.! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:18'!
lugaresDondeEstuvo
	^ lugaresDondeEstuvo! !

!HormigaMovil methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:18'!
lugaresDondeEstuvo: anObject
	lugaresDondeEstuvo := anObject! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:18'!
sumaDistanciaAcumuladaDesde: unaUbicacion
	self distanciaAcumulada:  ((self distanciaAcumulada)  + ((self ubicacion) distanciaA: unaUbicacion)).! !

!HormigaMovil methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:18'!
sumarDistanciaRecorridaDesde: unaUbicacion
	self distanciaRecorrida: ((self distanciaRecorrida) + ((self ubicacion) distanciaA: unaUbicacion)).! !

!HormigaMovil methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/26/2015 15:18'!
volveALaNormalidad
	self estado: EstadoNormal new.
	self dropeaExcesoDeCarga.! !

HormigaMovil subclass: #Obrera
	instanceVariableNames: 'alimentoTransportado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Obrera methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:41'!
alimentoTransportado
	^ alimentoTransportado! !

!Obrera methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:30'!
alimentoTransportado: anObject
	alimentoTransportado := anObject! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/26/2015 16:03'!
ataque
^2.! !

!Obrera methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:30'!
capacidadDisponible
	^((self estado) capacidadMaximaSegunEstado - self alimentoTransportado) ! !

!Obrera methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:31'!
depositaAlimentoEn: unHormiguero
	unHormiguero recibirAlimentoDeUnaHormiga: (self alimentoTransportado).
	self vaciarAlimentoTransportado.
! !

!Obrera methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/26/2015 15:32'!
dropeaExcesoDeCarga
	((self alimentoTransportado)  > 10) ifTrue:[ self alimentoTransportado: 10]! !

!Obrera methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/25/2015 22:41'!
entregarAlimentoA: unHormiguero
	(self estado) entregarAlimentoA: unHormiguero con: self.
	
	! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:31'!
esObrera
^true.! !

!Obrera methodsFor: 'yerbabrava' stamp: 'Anonymous 10/25/2015 22:42'!
estaAlLimite
	^ ((self alimentoTransportado) >=9) & ((self alimentoTransportado) <=10).! !

!Obrera methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/25/2015 22:42'!
extraerAlimentoDe: unaComida
	self moveteA: (unaComida ubicacion).
	(self estado) extraerDe: unaComida con: self.


	

	
	! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 10:47'!
initialize
	super initialize.
	alimentoTransportado := 0.
	! !

!Obrera methodsFor: 'yerbabrava' stamp: 'as 10/26/2015 17:59'!
recibirDaño: unaCantidad
	self morite! !

!Obrera methodsFor: 'yerbabrava' stamp: 'as 10/26/2015 17:31'!
tengoLugar
	^(self estado) tieneLugar: self.! !

!Obrera methodsFor: 'yerbabrava' stamp: 'Anonymous 10/26/2015 15:33'!
vaciarAlimentoTransportado
	self alimentoTransportado: 0! !

HormigaMovil subclass: #Soldado
	instanceVariableNames: 'vida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Soldado methodsFor: 'accessing' stamp: 'Anonymous 10/25/2015 22:42'!
alimentoTransportado
	^ 0.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 18:28'!
ataque
	^5.! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 18:27'!
descansar
	super descansar.
	self vida: 20.! !

!Soldado methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/25/2015 22:47'!
entregarAlimentoA: unHormiguero
	self moveteA: (unHormiguero ubicacion).
	
	! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/29/2015 12:32'!
esViolenta
^true.! !

!Soldado methodsFor: 'yerbabrava' stamp: 'as 10/26/2015 17:29'!
estaAlLimite
	^ false.! !

!Soldado methodsFor: 'yerbabrava' stamp: 'as 10/26/2015 18:45'!
evaluaSiTeMoris
	(self vida = 0) ifTrue:[ self morite].! !

!Soldado methodsFor: 'metodos cansadores' stamp: 'Anonymous 10/25/2015 22:43'!
extraerAlimentoDe: unaComida
	self moveteA: (unaComida ubicacion).


	
	! !

!Soldado methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 18:28'!
initialize 
	super initialize.
	vida:=20.! !

!Soldado methodsFor: 'yerbabrava' stamp: 'as 10/26/2015 18:39'!
recibirDaño: unInsecto
	super recibirDaño: unInsecto.
	self evaluaSiTeMoris.! !

!InsectoBase methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/26/2015 16:19'!
atacar: unInsecto
self moveteA: unInsecto ubicacion.
unInsecto recibirDaño: self.
! !

!InsectoBase methodsFor: 'accessing' stamp: 'as 10/26/2015 18:44'!
calculaVida: unInsecto
	^(self vida - (unInsecto ataque)) max:0.! !

!InsectoBase methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 18:43'!
recibirDaño: unInsecto
	self vida: (self calculaVida: unInsecto).! !

!InsectoBase methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 18:17'!
recibirDañoDeRebote
	self vida: self vida - 10.! !

!InsectoBase methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:51'!
ubicacion
	^ ubicacion! !

!InsectoBase methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 15:51'!
ubicacion: anObject
	ubicacion := anObject! !

!InsectoBase methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 16:00'!
vida
	^ vida! !

!InsectoBase methodsFor: 'accessing' stamp: 'Anonymous 10/26/2015 16:00'!
vida: anObject
	vida := anObject! !

InsectoBase subclass: #Langosta
	instanceVariableNames: 'vida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Langosta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/26/2015 16:25'!
initialize
	ubicacion := Ubicacion new.
	vida:=50.! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/26/2015 16:22'!
moveteA: unaUbicacion
self ubicacion: unaUbicacion.! !

!Langosta methodsFor: 'as yet unclassified' stamp: 'as 10/26/2015 18:46'!
recibirDaño: unInsecto
	super recibirDaño: unInsecto.
	unInsecto recibirDañoDeRebote.! !

Object subclass: #Ubicacion
	instanceVariableNames: 'unidadesX unidadesY'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Ubicacion commentStamp: '<historical>' prior: 0!
An Ubicacion is xxxxxxxxx.

Instance Variables
	unidadesX:		<Object>
	unidadesY:		<Object>

unidadesX
	- xxxxx

unidadesY
	- xxxxx
!

!Ubicacion methodsFor: 'accessing' stamp: 'as 10/18/2015 16:11'!
diferenciaEnXAlCuadrado: unaUbicacion
	^(self unidadesX - unaUbicacion unidadesX) raisedTo: 2 ! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 10/18/2015 16:11'!
diferenciaEnYAlCuadrado: unaUbicacion
	^(self unidadesY - unaUbicacion unidadesY) raisedTo: 2 ! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 10/18/2015 16:10'!
distanciaA: otraUbicacion
	^(((self diferenciaEnXAlCuadrado: otraUbicacion) + (self diferenciaEnYAlCuadrado: otraUbicacion)) sqrt).
! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesX
	^ unidadesX! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesX: anObject
	unidadesX := anObject! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesY
	^ unidadesY! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesY: anObject
	unidadesY := anObject! !
